import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
   Rain Gauge Design Competition
   Sample program: Mouse click counter

   Created on 2006-04-01[6]
   @author WONG Ka Yan [Ivy] 
      kywong@cs.hku.hk
      Dept. of Computer Science, HKU.
   @version 1.1
*/
public class MouseClick extends JFrame implements MouseListener{

    private static final int HEIGHT=700;
    private static final int WIDTH=700;

    private static final int FONT_SIZE=200;

    private JLabel label;
    private JPanel panel;

    private int count;  // store the count of mouse click

    /**
       Constructor.
    */
    public MouseClick(){
	this.count=0;
	layoutComponent();
	addMouseListener(this);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	pack();
	setVisible(true);
    }

    /**
       Put all components in the container.
    */
    protected void layoutComponent(){
	this.panel=new JPanel();
	panel.setPreferredSize(new Dimension(WIDTH, HEIGHT));

	this.label=new JLabel(new String("0"));
	this.label.setFont(new Font("Arial", Font.PLAIN, FONT_SIZE));
	panel.add(label);

	getContentPane().add(panel);
    }

    /**
       Update the label.
       @param count Number of detected mouse click
    */
    public void update(int count){
	this.label.setText((new Integer(count)).toString());
    }

    /**
       Defines the action after a mouse click is detected.
       Action: increases the number of count and updates the label
       @param event MouseEvent
     */
    public void mouseClicked(MouseEvent event){
	this.count++;
	update(count);
	System.out.println(count);
    }

    /**
       Main program
    */
    public static void main(String[] args){
	MouseClick mouseClickTest=new MouseClick();
    }

    //----------------------------------------------------------------------
    // Functions required by implementing mouseListener
    //----------------------------------------------------------------------
    public void mouseReleased(MouseEvent event){};
    public void mouseMoved(MouseEvent event){};
    public void mouseExited(MouseEvent event){};
    public void mouseEntered(MouseEvent event){};
    public void mousePressed(MouseEvent event){};
}
